using System;
using System.Runtime.InteropServices;
using LibVlcSharp;

namespace LibVlc
{
	public delegate void Callback(Event evt);

	public class EventManager : Object
	{
		[DllImport("vlc")]
		static extern int libvlc_event_attach(IntPtr manager, int type, CallbackNative cb, IntPtr data);
		[DllImport("vlc")]
		static extern void libvlc_event_detach(IntPtr manager, int type, CallbackNative cb, IntPtr data);
		[DllImport("vlc")]
		static extern IntPtr libvlc_event_type_name(int type);

		public EventManager (IntPtr raw) : base(raw)
		{
		}

		public bool Attach(EventType type, Callback cb){
			CallbackWrapper wrapper = new CallbackWrapper(cb);
			int i = libvlc_event_attach (Handle,(int)type,wrapper.native,IntPtr.Zero);
			return (i==1)?true:false;
		}

		public void Detach(EventType type, Callback cb){
			CallbackWrapper wrapper = new CallbackWrapper(cb);
			libvlc_event_detach (Handle,(int)type,wrapper.native,IntPtr.Zero);
		}

		public static string TypeName(EventType type){
			return Marshal.PtrToStringAuto (libvlc_event_type_name ((int)type));
		}
	}
}

