using System;
using System.Runtime.InteropServices;

namespace LibVlc
{
	public class MediaLibrary : Object
	{
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_library_new(IntPtr instance);
		[DllImport("vlc")]
		static extern int libvlc_media_library_load(IntPtr library);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_library_media_list(IntPtr library);

		public MediaLibrary (IntPtr raw) : base(raw)
		{}
		public MediaLibrary (Instance instance)
			: base(libvlc_media_library_new (instance.Handle))
		{}
		public bool Load(){
			return (libvlc_media_library_load (Handle)==0)?true:false;
		}
		public LibVlc.MediaList MediaList{
			get{
				return new LibVlc.MediaList(libvlc_media_library_media_list (Handle));
			}
		}
	}
}

