using System;
using System.Runtime.InteropServices;

namespace LibVlc
{
	public class MediaListPlayer : Object
	{
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_list_player_new(IntPtr instance);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_list_player_event_manager(IntPtr mlp);
		[DllImport("vlc")]
		static extern void  libvlc_media_list_player_set_media_player(IntPtr mlp, IntPtr mp);
		[DllImport("vlc")]
		static extern void  libvlc_media_list_player_set_media_list(IntPtr mlp, IntPtr ml);
		[DllImport("vlc")]
		static extern void libvlc_media_list_player_play(IntPtr mlp);
		[DllImport("vlc")]
		static extern void libvlc_media_list_player_pause(IntPtr mlp);
		[DllImport("vlc")]
		static extern int libvlc_media_list_player_is_playing(IntPtr mlp);
		[DllImport("vlc")]
		static extern int libvlc_media_list_player_get_state(IntPtr mlp);
		[DllImport("vlc")]
		static extern int libvlc_media_list_player_play_item_at_index(IntPtr mlp, int index);
		[DllImport("vlc")]
		static extern int libvlc_media_list_player_play_item(IntPtr mlp, IntPtr media);
		[DllImport("vlc")]
		static extern void libvlc_media_list_player_stop(IntPtr mlp);
		[DllImport("vlc")]
		static extern int libvlc_media_list_player_next(IntPtr mlp);
		[DllImport("vlc")]
		static extern int libvlc_media_list_player_previous(IntPtr mlp);
		[DllImport("vlc")]
		static extern void libvlc_media_list_player_set_playback_mode(IntPtr mlp,
                                                              int mode);

		public MediaListPlayer (IntPtr raw) : base(raw)
		{}
		public MediaListPlayer(Instance instance) 
			: base(libvlc_media_list_player_new (instance.Handle))
		{}
		public LibVlc.EventManager EventManager {
			get{
			return new LibVlc.EventManager(libvlc_media_list_player_event_manager (Handle));
			}
		}
		public LibVlc.MediaPlayer MediaPlayer{
			set{libvlc_media_list_player_set_media_player (Handle,value.Handle);}
		}
		public LibVlc.MediaList MediaList{
			set{libvlc_media_list_player_set_media_list (Handle,value.Handle);}
		}
		public void Play(){libvlc_media_list_player_play (Handle);}
		public void Pause(){libvlc_media_list_player_pause (Handle);}
		public bool IsPlaying(){
			return (libvlc_media_list_player_is_playing (Handle)==1)?true:false;
		}
		public State GetState(){
			return (State)libvlc_media_list_player_get_state (Handle);
		}
		public bool PlayItem(int index){
			return (libvlc_media_list_player_play_item_at_index (Handle,index)==0)?true:false;
		}
		public bool PlayItem(Media media){
			return (libvlc_media_list_player_play_item (Handle,media.Handle)==0)?true:false;
		}
		public bool Next(){
			return (libvlc_media_list_player_next (Handle)==0)?true:false;
		}
		public bool Previous(){
			return (libvlc_media_list_player_previous (Handle)==0)?true:false;
		}
		public void SetPlaybackMode(PlaybackMode mode){
			libvlc_media_list_player_set_playback_mode (Handle,(int)mode);
		}
	}
}

