using System;
using System.Runtime.InteropServices;

namespace LibVlc
{
	public class MediaPlayer : Object
	{
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_player_new(IntPtr instance);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_player_new_from_media(IntPtr media);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_media(IntPtr mp, IntPtr media);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_player_get_media(IntPtr mp);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_player_event_manager(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_media_player_is_playing(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_media_player_play(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_pause(IntPtr mp, int do_pause);
		[DllImport("vlc")]
		static extern void libvlc_media_player_pause(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_stop(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_nsobject(IntPtr mp, IntPtr drawable);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_player_get_nsobject(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_agl(IntPtr mp, uint agl);
		[DllImport("vlc")]
		static extern uint libvlc_media_player_get_agl(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_xwindow(IntPtr mp, uint drawable);
		[DllImport("vlc")]
		static extern uint libvlc_media_player_get_xwindow(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_hwnd(IntPtr mp, IntPtr handle);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_player_get_hwnd(IntPtr mp);
		[DllImport("vlc")]
		static extern long libvlc_media_player_get_length(IntPtr mp);
		[DllImport("vlc")]
		static extern long libvlc_media_player_get_time(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_time(IntPtr mp, long time);
		[DllImport("vlc")]
		static extern float libvlc_media_player_get_position(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_position(IntPtr mp, float pos);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_chapter(IntPtr mp, int chapter);
		[DllImport("vlc")]
		static extern int libvlc_media_player_get_chapter(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_media_player_get_chapter_count(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_media_player_will_play(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_media_player_get_chapter_count_for_title(IntPtr mp, int title);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_title(IntPtr mp, int title);
		[DllImport("vlc")]
		static extern int libvlc_media_player_get_title(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_media_player_get_title_count(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_previous_chapter(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_next_chapter(IntPtr mp);
		[DllImport("vlc")]
		static extern float libvlc_media_player_get_rate(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_set_rate(IntPtr mp, float rate);
		[DllImport("vlc")]
		static extern float libvlc_media_player_get_fps(IntPtr mp);
		[DllImport("vlc")]
		static extern uint libvlc_media_player_has_vout(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_media_player_is_seekable(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_media_player_can_pause(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_next_frame(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_media_player_navigate(IntPtr mp, uint mode);
		[DllImport("vlc")]
		static extern int libvlc_video_get_size(IntPtr mp, uint num, out int x, out int y);
		[DllImport("vlc")]
		static extern int libvlc_video_get_cursor(IntPtr mp, uint num, out int x, out int y);
		[DllImport("vlc")]
		static extern float libvlc_video_get_scale(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_video_set_scale(IntPtr mp, float scale);
		[DllImport("vlc")]
		static extern IntPtr libvlc_video_get_aspect_ratio(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_video_set_aspect_ratio(IntPtr mp,
		                             [MarshalAs(UnmanagedType.LPStr)] string ratio);
		[DllImport("vlc")]
		static extern int libvlc_video_get_spu(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_video_set_spu(IntPtr mp, int num);
		[DllImport("vlc")]
		static extern int libvlc_video_get_spu_count(IntPtr mp);
		[DllImport("vlc")]
		static extern IntPtr libvlc_video_get_spu_description(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_video_set_subtitle_file(IntPtr mp, 
		                               [MarshalAs(UnmanagedType.LPStr)]string file);
		[DllImport("vlc")]
		static extern long libvlc_video_get_spu_delay(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_video_set_spu_delay(IntPtr mp, long delay);
		[DllImport("vlc")]
		static extern IntPtr libvlc_video_get_title_description(IntPtr mp);
		[DllImport("vlc")]
		static extern IntPtr libvlc_video_get_chapter_description(IntPtr mp, int title);
		[DllImport("vlc")]
		static extern IntPtr libvlc_video_get_crop_geometry(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_video_set_crop_geometry(IntPtr mp,
		                                [MarshalAs(UnmanagedType.LPStr)] string geometry);
 		[DllImport("vlc")]
		static extern int libvlc_video_get_track_count(IntPtr mp);
		[DllImport("vlc")]
		static extern IntPtr libvlc_video_get_track_description(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_video_get_track(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_video_set_track(IntPtr mp, int num);
		[DllImport("vlc")]
		static extern int libvlc_video_take_snapshot(IntPtr mp, uint num,
		                            [MarshalAs(UnmanagedType.LPStr)] string filepath,
		                            uint width, uint height);
		[DllImport("vlc")]
		static extern void libvlc_video_set_deinterlace(IntPtr mp, 
                                    [MarshalAs(UnmanagedType.LPStr)] string mode);
		[DllImport("vlc")]
		static extern int libvlc_video_get_marquee_int(IntPtr mp, uint option);
		[DllImport("vlc")]
		static extern void libvlc_video_set_marquee_int(IntPtr mp, uint option, int val);
		[DllImport("vlc")]
		static extern IntPtr libvlc_video_get_marquee_string(IntPtr mp, uint option);
		[DllImport("vlc")]
		static extern void libvlc_video_set_marquee_string(IntPtr mp, uint option,
                                   [MarshalAs(UnmanagedType.LPStr)] string val);
		[DllImport("vlc")]
		static extern int libvlc_video_get_logo_int(IntPtr mp, uint option);
		[DllImport("vlc")]
		static extern void libvlc_video_set_logo_int(IntPtr mp, uint option,int val);
		[DllImport("vlc")]
		static extern void libvlc_video_set_logo_string(IntPtr mp, uint option, 
                                    [MarshalAs(UnmanagedType.LPStr)] string val);
		[DllImport("vlc")]
		static extern void libvlc_video_set_adjust_int(IntPtr mp, uint option, int val);
		[DllImport("vlc")]
		static extern int libvlc_video_get_adjust_int(IntPtr mp, uint option);
		[DllImport("vlc")]
		static extern float libvlc_video_get_adjust_float(IntPtr mp, uint option);
		[DllImport("vlc")]
		static extern void libvlc_video_set_adjust_float(IntPtr mp, uint option, float val);
 		[DllImport("vlc")]
		static extern int libvlc_audio_output_set(IntPtr mp,
                                      [MarshalAs(UnmanagedType.LPStr)] string name);
		[DllImport("vlc")]
		static extern void libvlc_audio_output_device_set(IntPtr mp,
                                      [MarshalAs(UnmanagedType.LPStr)] string output,
                                      [MarshalAs(UnmanagedType.LPStr)] string device);
		[DllImport("vlc")]
		static extern void libvlc_audio_toggle_mute(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_audio_get_mute(IntPtr mp);
		[DllImport("vlc")]
		static extern void libvlc_audio_set_mute(IntPtr mp, int val);
		[DllImport("vlc")]
		static extern int libvlc_audio_get_volume(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_audio_set_volume(IntPtr mp, int volume);
		[DllImport("vlc")]
		static extern int libvlc_audio_get_track_count(IntPtr mp);
		[DllImport("vlc")]
		static extern IntPtr libvlc_audio_get_track_description(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_audio_get_track(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_audio_set_track(IntPtr mp, int val);
		[DllImport("vlc")]
		static extern int libvlc_audio_get_channel(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_audio_set_channel(IntPtr mp, int val);
		[DllImport("vlc")]
		static extern long libvlc_audio_get_delay(IntPtr mp);
		[DllImport("vlc")]
		static extern int libvlc_audio_set_delay(IntPtr mp, long val);

		public MediaPlayer (IntPtr raw) : base(raw)
		{}
		public MediaPlayer(Instance instance)
			: base(libvlc_media_player_new (instance.Handle))
		{}
		public MediaPlayer(Media media)
			: base(libvlc_media_player_new_from_media (media.Handle))
		{}
		public LibVlc.Media Media{
			get{return new LibVlc.Media(libvlc_media_player_get_media (Handle));}
			set{libvlc_media_player_set_media (Handle,value.Handle);}
		}
		public LibVlc.EventManager EventManager{
			get{return new LibVlc.EventManager(libvlc_media_player_event_manager (Handle));}
		}
		public bool IsPlaying(){
			return (libvlc_media_player_is_playing (Handle)==1)?true:false;
		}
		public bool Play(){
			return (libvlc_media_player_play (Handle)==0)?true:false;
		}
		public void SetPause(bool do_pause){
			libvlc_media_player_set_pause (Handle,(do_pause)?1:0);
		}
		public void Pause(){libvlc_media_player_pause (Handle);}
		public void Stop(){libvlc_media_player_stop (Handle);}
		public IntPtr NsObject{
			get{return libvlc_media_player_get_nsobject (Handle);}
			set{libvlc_media_player_set_nsobject (Handle,value);}
		}
		public uint Agl{
			get{return libvlc_media_player_get_agl (Handle);}
			set{libvlc_media_player_set_agl (Handle,value);}
		}
		public uint XWindowId{
			get{return libvlc_media_player_get_xwindow (Handle);}
			set{libvlc_media_player_set_xwindow (Handle,value);}
		}
		public IntPtr WindowHandle{
			get{return libvlc_media_player_get_hwnd (Handle);}
			set{libvlc_media_player_set_hwnd (Handle,value);}
		}
		public long Length{get{return libvlc_media_player_get_length (Handle);}}
		public long Time{
			get{return libvlc_media_player_get_time (Handle);}
			set{libvlc_media_player_set_time (Handle,value);}
		}
		public float Position{
			get{return libvlc_media_player_get_position (Handle);}
			set{libvlc_media_player_set_position (Handle,value);}
		}
		public int Chapter{
			get{return libvlc_media_player_get_chapter (Handle);}
			set{libvlc_media_player_set_chapter (Handle,value);}
		}
		public int ChapterCount{get{return libvlc_media_player_get_chapter_count (Handle);}}
		public bool WillPlay(){
			return (libvlc_media_player_will_play (Handle)==1)?true:false;
		}
		public int ChapterCountTitle(int title){
			return libvlc_media_player_get_chapter_count_for_title (Handle,title);
		}
		public int Title{
			get{return libvlc_media_player_get_title (Handle);}
			set{libvlc_media_player_set_title (Handle,value);}
		}
		public int TitleCount{get{return libvlc_media_player_get_title_count (Handle);}}
		public void NextChapter(){libvlc_media_player_next_chapter (Handle);}
		public void PreviousChapter(){libvlc_media_player_previous_chapter (Handle);}
		public float Rate{
			get{return libvlc_media_player_get_rate (Handle);}
			set{libvlc_media_player_set_rate (Handle,value);}
		}
		public float Fps{get{return libvlc_media_player_get_fps (Handle);}}
		public uint VideoOutputCount{get{return libvlc_media_player_has_vout (Handle);}}
		public bool IsSeekable(){
			return (libvlc_media_player_is_seekable (Handle)==1)?true:false;
		}
		public bool CanPause(){
			return (libvlc_media_player_can_pause (Handle)==1)?true:false;
		}
		public void NextFrame(){
			libvlc_media_player_next_frame (Handle);
		}
		public void Navigate(NavigateMode mode){
			libvlc_media_player_navigate (Handle,(uint)mode);
		}
		public bool GetSize(uint video_number, out int x, out int y){
			return (libvlc_video_get_size (Handle,video_number,out x, out y)==0)?true:false;
		}
		public Point GetSize(uint video_number){
			Point p = new Point();
			libvlc_video_get_size (Handle,video_number,out p.x,out p.y);
			return p;
		}
		public bool GetCursor(uint video_number, out int x, out int y){
			return (libvlc_video_get_cursor (Handle,video_number,out x, out y)==0)?true:false;
		}
		public Point GetCursor(uint video_number){
			Point p = new Point();
			libvlc_video_get_cursor (Handle,video_number,out p.x,out p.y);
			return p;
		}
		public float VideoScale{
			get{return libvlc_video_get_scale (Handle);}
			set{libvlc_video_set_scale (Handle,value);}
		}
		public string AspectRatio{
			get{return Marshal.PtrToStringAuto (libvlc_video_get_aspect_ratio (Handle));}
			set{libvlc_video_set_aspect_ratio (Handle,value);}
		}
		public int CurrentSubtitles{
			get{return libvlc_video_get_spu (Handle);}
			set{libvlc_video_set_spu (Handle,value);}
		}
		public int SubtitlesCount{get{return libvlc_video_get_spu_count (Handle);}}
		//public TrackDescription SubtitleDescription{get{return new TrackDescription(libvlc_video_get_spu_description (Handle));}}
		public bool SetSubtitlesFile(string filename){
			return (libvlc_video_set_subtitle_file (Handle,filename)==1)?true:false;
		}
		public long SubtitlesDelay{
			get{return libvlc_video_get_spu_delay (Handle);}
			set{libvlc_video_set_spu_delay (Handle,value);}
		}
		//public TrackDescription TitleDescription{get{return new TrackDescription(libvlc_video_get_title_description (Handle));}}
		//public TrackDescription ChapterDescription(int title){return new TrackDescription(libvlc_video_get_chapter_description (Handle,title));}
		public string CropGeometry{
			get{return Marshal.PtrToStringAuto (libvlc_video_get_crop_geometry (Handle));}
			set{libvlc_video_set_crop_geometry (Handle,value);}
		}
		public int VideoTrackCount{get{return libvlc_video_get_track_count (Handle);}}
		//public TrackDescription VideoTrackDescription{get{return new TrackDescription(libvlc_video_get_track_description (Handle));}}
		public int CurrentVideoTrack{
			get{return libvlc_video_get_track (Handle);}
			set{libvlc_video_set_track (Handle,value);}
		}
		public bool TakeSnapshot(uint video_number,string path,uint width, uint height){
			return (libvlc_video_take_snapshot (Handle,video_number,path,width,height)==1)?true:false;
		}
		public int GetMarqueeInt(MarqueeOption option){
			return libvlc_video_get_marquee_int (Handle,(uint)option);
		}
		public void SetMarqueeInt(MarqueeOption option, int val){
			libvlc_video_set_marquee_int (Handle,(uint)option,val);
		}
		public string GetMarqueeString(MarqueeOption option){
			return Marshal.PtrToStringAuto (
				libvlc_video_get_marquee_string (Handle,(uint)option)
				);
		}
		public void SetMarqueeString(MarqueeOption option, string val){
			libvlc_video_set_marquee_string (Handle,(uint)option,val);
		}
		public int GetLogo(LogoOption option){
			return libvlc_video_get_logo_int (Handle,(uint)option);
		}
		public void SetLogo(LogoOption option, int val){
			libvlc_video_set_logo_int (Handle,(uint)option,val);
		}
		public void SetLogo(LogoOption option, string val){
			libvlc_video_set_logo_string (Handle,(uint)option,val);
		}
		public int GetVideoAjustInt(VideoAjustOption option){
			return libvlc_video_get_adjust_int (Handle,(uint)option);
		}
		public void SetVideoAjustInt(VideoAjustOption option,int val){
			libvlc_video_set_adjust_int (Handle,(uint)option,val);
		}
		public float GetVideoAjustFloat(VideoAjustOption option){
			return libvlc_video_get_adjust_float (Handle,(uint)option);
		}
		public void SetVideoAjustFloat(VideoAjustOption option, float val){
			libvlc_video_set_adjust_float (Handle,(uint)option,val);
		}
		public bool SetAudioOutput(string name){
			return (libvlc_audio_output_set (Handle,name)==0)?true:false;
		}
		public void SetAudioOutputDevice(string output, string device){
			libvlc_audio_output_device_set (Handle,output,device);
		}
		public void ToggleMute(){libvlc_audio_toggle_mute (Handle);}
		public bool Mute{
			get{return (libvlc_audio_get_mute(Handle)==1)?true:false;}
			set{libvlc_audio_set_mute (Handle,(value)?1:0);}
		}
		public int Volume{
			get{return libvlc_audio_get_volume (Handle);}
			set{libvlc_audio_set_volume (Handle,value);}
		}
		public int AudioTrackCount{get{return libvlc_audio_get_track_count (Handle);}}
		//public TrackDescription AudioTrackDescription {get{return new TrackDescription(libvlc_audio_get_track_description (Handle));}}
		public int CurrentAudioTrack{
			get{return libvlc_audio_get_track (Handle);}
			set{libvlc_audio_set_track (Handle,value);}
		}
		public int AudioChannel{
			get{return libvlc_audio_get_channel (Handle);}
			set{libvlc_audio_set_channel (Handle,value);}
		}
		public long AudioDelay{
			get{return libvlc_audio_get_delay (Handle);}
			set{libvlc_audio_set_delay (Handle,value);}
		}
	}
}

